

PB5_Process:
        brclr   SleepPB,portG,*        ;wait until PB released
        jsr     LCD_Clear
        jsr     SPI_Total_Test
        jmp     StartMain

SPI_Total_Test:
        jsr     _crlf
        ldhx    #SPI_Total_msg
        jsr     _puts
        jsr     _crlf

        jsr     LCD_Clear
        ldhx    #SPI_Total_msg
        jsr     disp_msg

        jsr     LCD_Clear
        jsr     SPI_Status_test
        lda     #$C0
        jsr     Cmnd2LCD
        ldhx    #SPI_total_msg1
        jsr     disp_msg
        jsr     wait500ms
        jsr     wait500ms

        jsr     LCD_Clear
        jsr     SPI_Write_test
        lda     #$C0
        jsr     Cmnd2LCD
        ldhx    #SPI_total_msg2
        jsr     disp_msg
        jsr     wait500ms
        jsr     wait500ms

        jsr     LCD_Clear
        jsr     SPI_Read_test
        bne     rd_failed
        lda     #$C0
        jsr     Cmnd2LCD
        ldhx    #SPI_total_msg3
        jsr     disp_msg
        rts
rd_failed:
        lda     #$C0
        jsr     Cmnd2LCD
        ldhx    #SPI_total_msg4
        jsr     disp_msg
        rts

SPI_Total_msg:  fcb 'SPI Test',0
SPI_Total_msg1: fcb 'Status Complete',0
SPI_Total_msg2: fcb ' Write Complete',0
SPI_Total_msg3: fcb ' Read OK',0
SPI_Total_msg4: fcb ' Read Failed',0

SPI_Status_test:
        ldhx    #SPI_Status_msg
        jsr     disp_msg

        jsr     _crlf
        ldhx    #SPI_Status_msg
        jsr     _puts
        jsr     _crlf



; ---- Initialize SPI

        jsr     SPI_Init

        jsr     SPI_DeviceReady       ; wait for device ready then ready back result
        ldhx    #RDY_MSG
        jsr     prt_msg_byte

        jsr     SPI_WriteEnable     ; test setting write enable bit
        ldhx    #WEN_MSG
        jsr     _puts
        jsr     _crlf

        jsr     SPI_DeviceReady       ; wait for device ready then ready back result
        ldhx    #RDY_MSG
        jsr     prt_msg_byte

        lda     #$0C
        jsr     SPI_WriteStatusReg   ;  turn on block protect bits
        lda     #$0C
        ldhx    #WSR_MSG
        jsr     prt_msg_byte

        jsr     SPI_ReadStatusReg     ; Read status reg
        ldhx    #RSR_MSG
        jsr     prt_msg_byte

        jsr     SPI_WriteEnable     ; test setting write enable bit
        ldhx    #WEN_MSG
        jsr     _puts
        jsr     _crlf

        lda     #$00
        jsr     SPI_WriteStatusReg   ;  turn off block protect bits
        lda     #$00
        ldhx    #WSR_MSG
        jsr     prt_msg_byte

        jsr     SPI_ReadStatusReg     ; Read status reg
        ldhx    #RSR_MSG
        jsr     prt_msg_byte

        rts

SPI_Status_msg:  fcb     'SPI Status Reg Test',0
RSR_MSG:     fcb     'Rd Status Complete statusReg=',0
RDY_MSG:     fcb     'Now Ready statusReg=',0
WEN_Msg      fcb     'Write enable sent',0
WSR_MSG:     fcb     'Write SR=>',0




SPI_Write_test:
        ldhx    #SPI_Write_msg
        jsr     disp_msg



; ------ Write all Pages  each page in 1st 32K has different byte pattern
; -----                   each page in 2nd 32K repeats the pattern
; -----                   i.e. page 0 and page 128
; -----                        page 1 and page 129 have same pattern
        jsr     SPI_Init

        jsr     _crlf
        ldhx    #SPI_Write_msg
        jsr     _puts
        jsr     _crlf

        ; put pattern in buffers WR_First_Byte is value in 1st
        ;   byte of page - by changing this you can be sure that
        ;   revided code actually writes to SEEPROM so on read back
        ;  you see new not old data - been bitten by this before!!
        ;   Inital value is in WR_First_Initial and is used also by read verify
        ;  to use new patternonly need to change WR_First_Initial

        ldhx    #SPI_buffer1    ; Build intial argument list for write
        sthx    SPI_Args
        clr     SPI_Args+2
        mov     #$00,SPI_Args+3  ;  Args: Ram Addr=SPI_buffer1,SEEPROM Offset= $0000
        
        lda     #$17
        sta     WR_First_initial
        lda     WR_First_Initial               ; initial pattern byte
        sta     WR_First_Byte

Writeloop1:
        ldhx    #SPI_buffer1
send_buffer_loop1:         ; setup pattern in buffer 256 bytes starting with
        sta     ,x         ; WR_First_Byte-1,WR_First_Byte-2,,WR_First_Byte+1,WR_First_Byte
        aix     #1
        deca
        cmpa    WR_First_Byte
        bne     send_buffer_loop1

        jsr     SPI_DeviceReady         ; wait for any previous write cycle to complete

        ldhx    #SPI_Args
        jsr     SPI_WriteEnable
        jsr     SPI_WritePage      ; write 1 page

        ldhx    #SPI_buffer2    ; move to second buffer
        sthx    SPI_Args
        ldhx    SPI_Args+2      ; advance SEEPROM pointer 128 bytes
        aix     #$40
        aix     #$40
        sthx    SPI_Args+2

        jsr     SPI_DeviceReady         ; wait for previous write cycle to complete

        ldhx    #SPI_Args            ;write next page
        jsr     SPI_WriteEnable
        jsr     SPI_WritePage

        ldhx    #SPI_buffer1    ; return buffer to 1st page of pattern
        sthx    SPI_Args
        ldhx    SPI_Args+2      ; advance SEEPROM pointer 128 bytes
        aix     #$40
        aix     #$40
        sthx    SPI_Args+2
        lda     WR_First_Byte   ; increment first byte to make next 2 pages have new pattern
        inca
        sta     Wr_First_Byte
        cmphx   #$0000          ; are we done yet?
        bne     Writeloop1

write_exit:


        ldhx    #WR_MSG
        jsr     _puts
        jsr     _crlf
        rts


SPI_Write_msg:     fcb     'SPI Write Test',0
WR_MSG       fcb     'WriteComplete 64K',0





SPI_Read_test:
        ldhx    #SPI_Read_msg
        jsr     disp_msg

        jsr     SPI_Init

        jsr     _crlf
        ldhx    #SPI_Read_msg
        jsr     _puts



        jsr     SPI_DeviceReady       ; wait for device ready then ready back result
        psha             ; save returned status reg
        jsr     _crlf
        ldhx    #RDY_MSG
        jsr     _puts
        pula
        jsr     _byte_sp
        jsr     _crlf


        lda     #7                ; set buffers to 7,6,5,..0,255,,,,,,,8
        ldhx    #SPI_buffer1
clr_buffer_loop:
        sta     ,x
        aix     #1
        deca
        cmpa    #7
        bne     clr_buffer_loop

        lda     WR_First_Initial  ; setup for verify
        sta     WR_First_Byte

        ldhx    #SPI_buffer1    ;  Build argument intial list for read
        sthx    SPI_Args
        clr     SPI_Args+2
        clr     SPI_Args+3       ;Args: 128 bytes,Ram Addr=SPI_buffer1,SEEPROM Offset= $0000




Read_Loop:
        lda     #128             ;
        ldhx    #SPI_Args        ;  Args: 128 bytes,Ram Addr=SPI_buffer1
        jsr     SPI_Read

        ldhx    #SPI_buffer2    ; advance buffer to 2nd page of pattern
        sthx    SPI_Args
        ldhx    SPI_Args+2      ; advance SEEPROM pointer 128 bytes
        aix     #$40
        aix     #$40
        sthx    SPI_Args+2

        lda     #128             ;  read next page
        ldhx    #SPI_Args        ;  Args: 128 bytes,Ram Addr=SPI_buffer1
        jsr     SPI_Read

        lda     WR_First_Byte    ; chk buffer
        ldhx    #SPI_buffer1
chk_buffer_loop:
        cmp     ,x
        bne     chk_fail
        aix     #1
        deca
        bne     chk_buffer_loop

        lda     WR_First_Byte   ; increment first byte to next pattern
        inca
        sta     Wr_First_Byte

        ldhx    #SPI_buffer1    ; restore buffer pointer to first buffer
        sthx    SPI_Args
        ldhx    SPI_Args+2      ; advance SEEPROM pointer 128 bytes
        aix     #$40
        aix     #$40
        sthx    SPI_Args+2
        cmphx   #$0000          ; are we done yet?
        bne     Read_Loop


        ldhx    #RD_MSG
        jsr     _puts
        jsr     _crlf
        clra                    ; indicate success
        rts

chk_fail:
        jsr     _crlf
        ldhx    #RD_Fail_Msg
        jsr     _puts
        jsr     _crlf
        lda     #1              ; indicate failure
        rts

SPI_Read_msg:     fcb     'SPI Read Test',0

RD_FAIL_MSG:    fcb     'Read Failed ',0
RD_MSG:         fcb     'Read 64k Verify All OK',0




