;*********************************************************************************
;*********************************************************************************
;                           Link Process
;*********************************************************************************
;*********************************************************************************

Link_process:
	lda	lchar		        ; get the char received
	sub	#"0"		        ; get the command
	bmi	NoLink		        ; bad request

; Detemine the band value
	asla			        ; mult by 2
	cmp	#LinkBandSz	        ; valid?
	bge	NoLink

	ldhx	#LinkBandTable	        ; base of the table
	pshhx
	add	2,sp		        ; add the offset
	sta	2,sp
	lda	1,sp
	adc	#0
	sta	1,sp		        ; routine Address pointer is on the stack

	pulhx

	ldhxx			        ; get the routine address
	jsr	SetEdges	        ; Set the Band

        mov     Scan_start+0,F_min+0    ;Put lowest freq in selected band into F_min registers
        mov     Scan_start+1,F_min+1    ;so display goes there when we go back to to Impedance mode
        mov     Scan_start+2,F_min+2
        mov     Scan_start+3,F_min+3
        mov     Scan_start+4,F_min+4
        mov     Scan_start+5,F_min+5
        mov     Scan_start+6,F_min+6

	jmp	Scan_process	        ; no run the scan

NoLink:
        jmp     Impedance	        ; go directly into Impedance Mode with freq at min SWR point

;--------------------------
;   Band JUMP TABLE

LinkBandTable:
        fdb     low_edges
        fdb     mid_edges
        fdb     hi_edges
        fdb     Custom_Start
        fdb     m10_edge
        fdb     m12_edge
        fdb     m15_edge
        fdb     m17_edge
        fdb     m20_edge
        fdb     m30_edge
        fdb     m40_edge
        fdb     m80_edge
        fdb     m160_edge
LinkBandSz	equ *-LinkBandTable

             ; Custom Band Selection
lCustomBand:
        mov     Custom_Start+0,Scan_Start+0     ;set START frequency registers (MSB) to  (LSB)
        mov     Custom_Start+1,Scan_Start+1
        mov     Custom_Start+2,Scan_Start+2
        mov     Custom_Start+3,Scan_Start+3
        mov     Custom_Start+4,Scan_Start+4
        mov     Custom_Start+5,Scan_Start+5
        mov     Custom_Start+6,Scan_Start+6
        mov     Custom_End+0,Scan_End+0         ;set END frequency registers (MSB) to  (LSB)
        mov     Custom_End+1,Scan_End+1
        mov     Custom_End+2,Scan_End+2
        mov     Custom_End+3,Scan_End+3
        mov     Custom_End+4,Scan_End+4
        mov     Custom_End+5,Scan_End+5
        mov     Custom_End+6,Scan_End+6
        rts

